"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var _ = require("underscore");
var React = require("react");
var classNames = require("classnames");
var form_1 = require("../form");
var RadioInput = (function (_super) {
    __extends(RadioInput, _super);
    function RadioInput() {
        return _super.apply(this, arguments) || this;
    }
    RadioInput.prototype.render = function () {
        var id = form_1.generateUniqueId(function (u) { return "radio_" + u; });
        var classes = classNames("radio", this.props.className, {
            "show-validation": (this.props.validationMode !== "none" && this.props["data-validation-message"])
        });
        return (React.createElement("div", { className: classes, title: this.props["data-validation-message"] },
            React.createElement("input", __assign({ id: id }, _.omit(this.props, "labelContent", "validationMode"), { type: "radio", "data-validation-message": this.props["data-validation-message"] })),
            React.createElement("label", { htmlFor: id }),
            React.createElement("label", { className: "radio-label", htmlFor: id }, this.props.labelContent)));
    };
    return RadioInput;
}(React.Component));
RadioInput.defaultProps = {
    validationMode: "none"
};
exports.RadioInput = RadioInput;
